package com.link.microservice.config;

import com.link.core.basic.interceptor.SecurityInterceptor;
import feign.RequestInterceptor;
import feign.RequestTemplate;
import java.util.Enumeration;
import javax.servlet.http.HttpServletRequest;
import org.springframework.web.context.request.RequestContextHolder;
import org.springframework.web.context.request.ServletRequestAttributes;

public class FeignBasicAuthRequestInterceptor implements RequestInterceptor {
   public static final ThreadLocal<String> xxlNoInterceptSign = new ThreadLocal();
   private String XXL_NOINTERCEPT = "NoIntercept";
   public static final String INNER_TOKEN = "INNERTOKEN";

   public void apply(RequestTemplate requestTemplate) {
      ServletRequestAttributes attributes = (ServletRequestAttributes)RequestContextHolder.getRequestAttributes();
      if (null != attributes && this.checkExistInnernalToken(attributes)) {
         HttpServletRequest request = attributes.getRequest();
         Enumeration<String> headerNames = request.getHeaderNames();
         if (headerNames != null) {
            while(headerNames.hasMoreElements()) {
               String name = (String)headerNames.nextElement();
               String values = request.getHeader(name);
               requestTemplate.header(name, new String[]{values});
            }
         }

      } else if (this.XXL_NOINTERCEPT.equals(xxlNoInterceptSign.get())) {
         requestTemplate.header(this.XXL_NOINTERCEPT, new String[]{this.XXL_NOINTERCEPT});
         requestTemplate.header("LinkRequestId", new String[]{(String)SecurityInterceptor.linkRequestId.get()});
      } else {
         requestTemplate.header("INNERTOKEN", new String[]{(String)SecurityInterceptor.internal_token.get()});
         requestTemplate.header("Authorization", new String[]{(String)SecurityInterceptor.token.get()});
         requestTemplate.header("LinkRequestId", new String[]{(String)SecurityInterceptor.linkRequestId.get()});
      }
   }

   private boolean checkExistInnernalToken(ServletRequestAttributes attributes) {
      HttpServletRequest request = attributes.getRequest();
      Enumeration<String> headerNames = request.getHeaderNames();
      if (headerNames != null) {
         while(headerNames.hasMoreElements()) {
            String name = (String)headerNames.nextElement();
            if ("INNERTOKEN".equals(name)) {
               return true;
            }
         }
      }

      return false;
   }
}
